//Pokusne ovladani displeje 788ASER matice 8x8 se spol. Anodou
//Katody (COLS) jsou spinany pres ULN2803 a odpory (100-220R)
//Anody (ROWS) jsou spinany pres TBD62783
//Arduino Pro Mini 168/328
//pouzite IDE: 1.0.5-r2

//obsazeni pinu Arduina Pro Mini a displeje 8x8 (viz. datasheet 788ASR)
//COL 1-8 = pin 2-9 = katody zleva doprava, akt. H
//ROW 1-8 = pin 10-17 (do A3) = anody shora dolu, akt. H

#define  row0    10        //1. pin radku
#define  col0    2         //1. pin sloupce

//Zobrazovany pattern (1=sviti)
const boolean pattern[8][8] = {{0,0,1,1,1,1,0,0},      //smajlik
                               {0,1,0,0,0,0,1,0},
                               {1,0,1,0,0,1,0,1},
                               {1,0,0,0,0,0,0,1},
                               {1,0,1,0,0,1,0,1},
                               {1,0,0,1,1,0,0,1},
                               {0,1,0,0,0,0,1,0},
                               {0,0,1,1,1,1,0,0}};

void setup() {                       //nastaveni funkce pinu 2-17 na vystup = L    
  for (byte i=2; i<18; i++){
  pinMode(i, OUTPUT);     
  digitalWrite(i, LOW); 
  }
}

void loop() {

//  Postupne spinani po 1 LED (anody primo na vystupech Arduina, nez prislo pole):
//  for (byte r=0; r<8; r++){ 
//  for (byte c=0; c<8; c++){
//  digitalWrite(row0+r, HIGH);  
//  digitalWrite(col0+c, pattern[r][c]);  
//  delay(125);
//  digitalWrite(row0+r, LOW);  
//  digitalWrite(col0+c, LOW);  
//  delay(1);
//  }
//  }

//Multiplex (anody spinany pomoci "PNP" pole TBD62783):
    for (byte r=0; r<8; r++){                   //pro kazdy radek  
      for (byte c=0; c<8; c++){                 //pro kazdy sloupec
      digitalWrite(col0+c, pattern[r][c]);      //vystav stav katod
      }
    digitalWrite(row0+r, HIGH);                 //zapni anodu daneho radku 
    delay(2);                                   //pockej
    digitalWrite(row0+r, LOW);                  //vypni anodu daneho radku (aby nebyli duchove)
    }
  
}

